<template>
  <div v-if="types == 'addItem'" class="grid-item" v-wave>
    <div class="grid-item__add" @click="$emit('addNewItem', 'event')">
      <svg-icon name="plus" />
      <div class="title">Create new</div>
    </div>
  </div>
  <div v-else class="grid-item">
    <div class="grid-item__top" :class="{ 'none-photo': !data.cover }">
      <div class="grid-item__status">
        <span v-if="data.nft">NFT</span>
        <span class="new">{{ data.type }}</span>
      </div>
      <template v-if="data.cover">
        <blur-hash-image
          v-if="data.cover.blurhash"
          :hash="data.cover.blurhash"
          :src="`/storage/${data.cover.preview_url}`"
          class="blurhash"
        />
        <img v-else :src="`/storage/${data.cover.preview_url}`" />
      </template>
      <svg-icon v-else name="photo" />
    </div>
    <div class="grid-item__bottom">
      <div class="grid-item__title">
        <nuxt-link
          :to="localePath(`/users/${data.user.username}/store/${data.id}`)"
        >
          {{ data.name }}
        </nuxt-link>
      </div>
      <div class="grid-item__information">
        <div class="grid-item__tags">
          <el-tag v-if="data.duration" type="info" size="small" border>
            <span>{{ data.duration }} hrs.</span>
          </el-tag>
          <el-tag type="info" size="small" border>
            <span>{{ data.category }}</span>
          </el-tag>
          <el-tag v-if="data.nft" type="success" size="small">
            <span>NFT</span>
          </el-tag>
        </div>
        <div class="grid-item__price">
          <!-- <div class="conversion">~35$</div> -->
          <div class="value">
            {{ data.price }}
            <template v-if="data.currency == 'USDN'">$</template>
          </div>
        </div>
      </div>
      <div v-if="data.location">
        <div>
          {{
            [data.location.city, data.location.country]
              .filter(e => !!e)
              .join(', ')
          }}
        </div>
        <!-- <div>0.0</div> -->
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, reactive } from '@nuxtjs/composition-api'
import elTag from '@/components/element/Tag.vue'
export default defineComponent<{
  types: String
  data: Object
}>({
  name: 'StoreItem',
  props: ['types', 'data'],
  components: {
    elTag
  },
  setup(_, { root, emit }) {
    const handleClick = (event: any) => {
      emit('click', event)
    }
    return {
      handleClick
    }
  }
})
</script>

<style lang="scss" scoped>
.grid {
  &-item {
    background: #272c3b;
    border-radius: 10px;
    overflow: hidden;
    &__add {
      min-height: 250px;
      height: 100%;
      display: flex;
      align-items: center;
      justify-content: center;
      flex-direction: column;
      user-select: none;
      cursor: pointer;
      transition: 250ms all;
      .icon {
        width: 55px;
        height: 55px;
        background: #3b435a;
        border-radius: 50%;
        margin-bottom: 15px;
        padding: 18px;
        fill: #fff;
      }
      .title {
        letter-spacing: -0.75px;
        color: #ffffff;
        font-weight: bold;
        font-size: 30px;
        line-height: 33px;
      }
    }
    &__status {
      position: absolute;
      left: 25px;
      top: 25px;
      z-index: 2;
      font-size: 0px;
      span {
        display: inline-block;
        background: #272c3b;
        border-radius: 20px;
        padding: 10px 20px;
        letter-spacing: 0.7px;
        color: #fff;
        font-weight: bold;
        font-size: 14px;
        line-height: 18px;
        text-transform: uppercase;
        margin-right: 12px;
        margin-bottom: 5px;
        &.new {
          color: #00ffb3;
          background: #272c3b;
        }
        &.purchased {
          background: #fff;
          color: #7683ad;
        }
      }
    }
    &__category {
      position: absolute;
      left: 25px;
      top: 25px;
      z-index: 2;
      span {
        background: #272c3b;
        border-radius: 20px;
        padding: 10px 20px;
        letter-spacing: 0.7px;
        color: #fff;
        font-weight: bold;
        font-size: 14px;
        line-height: 18px;
        text-transform: uppercase;
        &.green {
          color: #00ffb3;
        }
        &.yellow {
          color: #ffff00;
        }
        &.pink {
          color: #ce73e3;
        }
        &.blue {
          color: #2bb6ff;
        }
        &.orange {
          color: #e8983a;
        }
      }
    }
    &__top {
      height: 280px;
      display: flex;
      position: relative;
      > a {
        position: absolute;
        left: 0px;
        right: 0px;
        top: 0px;
        bottom: 0px;
        z-index: 2;
      }
      ::v-deep {
        .blurhash {
          flex: 1;
          padding-bottom: 0px !important;
          img {
            object-fit: cover;
          }
        }
      }
      &.none-photo {
        background: rgba(#7683ad, 0.15);
        display: flex;
        align-items: center;
        justify-content: center;
        svg {
          width: 50px;
          height: 50px;
          fill: #00ffb3;
        }
      }
    }
    &__bottom {
      padding: 20px 30px;
    }
    &__title {
      letter-spacing: 0px;
      color: #ffffff;
      font-weight: bold;
      font-size: 28px;
      line-height: 33px;
      margin-bottom: 20px;
    }
    &__information {
      margin-bottom: 25px;
      display: flex;
      align-items: center;
      justify-content: space-between;
      &:last-child {
        margin-bottom: 0px;
      }
    }
    &__price {
      letter-spacing: 0px;
      color: #ffffff;
      font-size: 30px;
      line-height: 39px;
      font-weight: 900;
      text-align: right;
      .conversion {
        letter-spacing: 0px;
        color: #9badd6;
        font-size: 18px;
        line-height: 20px;
        text-transform: uppercase;
      }
    }
  }
}
</style>
